100 :
110 REMark *************************************************************
120 REMark * The following two lines instruct Turbo how to compile EX1 *
130 REMark *************************************************************
140 :
150 TURBO_objfil 'ram1_EX1_TASK':TURBO_taskn 'EX1 v2.2':TURBO_objdat 100
160 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
170 :
180 REMark EX1_bas v2.2
190 REMark 18 DEC 00
200 :
210 IF COMPILED:OPEN#0,con:wch%=100:ELSE :BOUTL:wch%=0
220 :
230 REMark **************************************
240 REMark * wch% is used by M_SETUP, see later *
250 REMark **************************************
260 :
270 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
280 :
290 REMark **********************************************************************
300 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
310 REMark * and sets wd(r), the address(es) of window definition(s)            *
320 REMark **********************************************************************
330 :
340 REMark                **************************************
350 OPEN#4,con:    REMark * ex1 - for use in writing etc       *
360 DIM str$(0,32):REMark * ex1 - string to contain directory  *
370 REMark                **************************************
380 :
390 REMark                            **************************************
400 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
410 push:          REMark             *      - sets a null menu  -         *
420 REMark                            **************************************
430 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
440 REMark ************************************************************
450 REMark * We must set a primary window here if this is COMPILED .  *
460 REMark * (PRPOS can be thought of as PRimary POSitioned)          *
470 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
480 REMark * the window here must instead be "pulled down".           *
490 REMark ************************************************************
500 REMark                             *********************************
510 SET_CHANNEL#4,SWIN(2,0,wwd):REMark *  sets #4                      *
520 D_LDRW 16*65536+3,wwd:REMark       *  makes COPY unavailable       *
530 prap:          REMark              *  prints in application window *
540 REMark                             *********************************
550 :
560 REMark *******************************************************
570 REMark * This is the repeat loop for reading the pointer and *
580 REMark * taking apropriate action                            *
590 REMark *******************************************************
600 :
610 REPeat lp
620  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
630  r=255&&get_x%(k)
640  SELect ON r
650   =255:REMark loose items
660     IF do_loose%(get_y%(k)):EXIT lp
670   =254:REMark event
680     IF do_event%(get_y%(k)):EXIT lp
690   =REMAINDER :REMark application window k
700     do_app r,get_y%(k)
710  END SELect
720 END REPeat lp
730 STOP
740 :
750 DEFine PROCedure finish
760  PRINT#0,"ENDED":BUNST wwd:CLOS chid:REMark *  the window is removed *
770  CLOSE#4:
780  BRECHP:REMark *  all ALCHPd space returned to the heap *
790 END DEFine
800 :
810 DEFine FuNction do_loose%(num)
820  REMark *********************************************
830  REMark * routine to do loose items                 *
840  REMark * this returns 1 for "finished" else 0      *
850  REMark *  the four loose items are 0 = move sprite *
860  REMark *                           1 = ESC         *
870  REMark *                           2 = DISPLAY     *
880  REMark *                           3 = COPY        *
890 REMark **********************************************
900  LOCal ov%,pum
910  ov%=0:pum=num
920  SELect ON pum
930   =1:finish:ov%=1
940   =0:mve1
950  REMark ***************************************************
960  REMark *  set_st puts the directory of FLP1 to str$      *
970  REMark *  D_LDRW 3 & 2 set DISPLAY and COPY to available *
980  REMark *  BWRSET redraws the window with the directory   *
990  REMark ***************************************************
1000 :
1010   =2:set_st:D_LDRW 3,wwd:D_LDRW 2,wwd:BWRSET wwd
1020 :
1030  REMark ***************************************************
1040  REMark *  do_cop copies selected files                   *
1050  REMark *  push sets a null menu                          *
1060  REMark *  RECHP adr returns space used for the menu      *
1070  REMark ***************************************************
1080 :
1090   =3:do_cop:push:RECHP adr:REMark to copy str$ files
1100   =REMAINDER :ov%=1
1110  END SELect
1120  RETurn ov%
1130 END DEFine
1140 :
1150 DEFine FuNction do_event%(num%)
1160  REMark carry out event
1170  REMark only move and escape now
1180  LOCal ov%
1190  ov%=0
1200  IF 2&&num%:finish:ov%=1
1210  IF 8&&num%:mve1
1220  RETurn ov%
1230 END DEFine
1240 :
1250 DEFine PROCedure do_app(wind%,num%)
1260  REMark *********************************
1270  REMark * to do the menu item no num%   *
1280  REMark * in window number wind%        *
1290  REMark * no action need be taken here  *
1300  REMark *********************************
1310 :
1320 END DEFine
1330 :
1340 DEFine PROCedure mve1
1350  REMark to move window
1360  BCHWIN wwd
1370  D_LDRW 0,wwd
1380  SET_CHANNEL#4,SWIN(2,0,wwd)
1390 END DEFine
1400 :
1410 DEFine PROCedure prap
1420  REMark ******************************************
1430  REMark * this overwrites the application window *
1440  REMark * which now has a null menu              *
1450  REMark ******************************************
1460 :
1470  USE 4:CLS:PAPER BLACK%:OVER 0:INK WHITE%
1480  AT 2,2:PRINT "DISPLAY:":AT 5,2:PRINT "COPY:"
1490  INK GREEN%
1500  AT 3,3:PRINT "Shows files from flp1_"
1510  AT 6,3:PRINT "Copies selected files to ram1_"
1520  USE
1530 END DEFine
1540 :
1550 DEFine PROCedure set_st
1560  REMark * ex1 - to put flp1_ directory to application via str$ *
1570  LOCal x,k%,ch%,a$,lp,lp1,z,m%,top
1580  ch%=FOP_OVER("ram1_ddf"):REMark The quotation marks are needed to stop Turbo taking ram1_ddf as 0
1590  IF ch%<0:finish
1600  WDIR#ch%,"flp1_" :REMark The quotation marks are needed to stop Turbo taking flp1_ as 0
1610  SET_POSITION#ch%,0:k%=0:USE ch%:m%=0
1620  REPeat lp
1630   IF EOF(#ch%):EXIT lp
1640   INPUT a$:IF "->" INSTR a$:NEXT lp
1650   k%=k%+1:m%=max%(m%,LEN(a$))
1660  END REPeat lp
1670  m%=ev%(m%):REMark round up to even
1680  REMark k%=number of files:m%=max length of name
1690  DIM str$(k%,m%)
1700  SET_POSITION#ch%,0:x=1
1710  REPeat lp1
1720   IF EOF(#ch%):EXIT lp1
1730   INPUT a$:IF "->" INSTR a$:NEXT lp1
1740   str$(x)=a$:x=x+1
1750  END REPeat lp1
1760  USE:CLOSE#ch%
1770 :
1780  REMark **************************************
1790  REMark * adr -> the space used for the menu *
1800  REMark **************************************
1810 :
1820  adr=set_ap(str$,0,wwd)
1830 END DEFine
1840 :
1850 DEFine PROCedure do_cop
1860  REMark                     **********************************
1870  REMark                     * To copy marked files to ram1_  *
1880  LOCal x,ad,ae,k%
1890  ad=addr_appw(0,wwd):REMark *  address of status area        *
1900  ae=AD_SUB(0,1,wwd): REMark *  address of app. window        *
1910  k%=PEEK_W(ae+146):  REMark *  no of rows = items            *
1920  FOR x=1 TO k%
1930                      REMark *  ad+x-1 is 128 for 'selected'  *
1940  REMark                     **********************************
1950   IF PEEK(ad+x-1):COPY "flp1_"&str$(x),"ram1_"&str$(x)
1960  END FOR x
1970  POKE_L ae+20,0:POKE_L ae+28,0:REMark * to stop menu items  *
1980  D_LDRW 16*65536+3,wwd:prap
1990 END DEFine
2000 :
2010 DEFine PROCedure push
2020  REMark *  to set a null menu *
2030  LOCal ae
2040 :
2050  REMark                     **************************
2060  ae=AD_SUB(0,1,wwd): REMark * address of app. window *
2070  POKE_L ae+70,0:REMark      * no y-control block     *
2080  POKE_L ae+28,0:REMark      * no control routine     *
2090  POKE_L ae+32,0:REMark      * no control sections    *
2100  POKE_L ae+20,0:REMark      * no draw routine        *
2110  POKE_L ae+152,0:POKE_L ae+156,0:POKE_L ae+168,0
2120  POKE_L ae+144,0:REMark     * no rows OR cols        *
2130  POKE_L ae+100,0:REMark     * no status block        *
2140  POKE_W ae+150,6:REMark     * room for arrows        *
2150  REMark                     **************************
2160 :
2170  POKE_W ae+94,GREEN%:POKE_W ae+94+4,GREEN%:REMark * arrows *
2180 END DEFine
2190 :
2200 REMark ********************************************************
2210 REMark * The following DATA lines contain all the             *
2220 REMark * information needed to set up the windows in EX1.     *
2230 REMark * This includes the window sizes, the colours, and     *
2240 REMark * sprites wanted. It also contains the sprites, blobs, *
2250 REMark * or patterns themselves. All this is unravelled and   *
2260 REMark * set in the window definitions by Set_Win.            *
2270 REMark ********************************************************
19600 DATA 2244
19601 DATA 20,17747,17162,17481,21328,19521,22794,17231
19602 DATA 20569,2592,2570,1888,1446,1780,1,6
19603 DATA 150,256,8192,5,5,2,2,0
19604 DATA 12,0,28,0,44,0,0,8224
19605 DATA 0,20560,0,8224,0,0,0,8224
19606 DATA 0,28784,0,-1800,0,28784,0,8224
19607 DATA 0,256,16384,9,7,4,3,0
19608 DATA 12,0,36,0,0,0,0,2056
19609 DATA 0,5140,0,8738,0,5140,0,2056
19610 DATA 0,0,0,2056,0,7196,0,15934
19611 DATA 0,32639,0,15934,0,7196,0,2056
19612 DATA 0,256,8192,41,26,20,1,0
19613 DATA 12,0,320,0,628,0,0,10794
19614 DATA 0,0,0,771,-1,5140,32639,-7968
19615 DATA 0,1031,255,-27500,-32513,4336,0,2063
19616 DATA 255,21973,255,2296,0,4382,19125,8931
19617 DATA 10710,17596,0,4127,255,5367,255,1276
19618 DATA 0,9023,4863,5367,9471,25342,0,9279
19619 DATA -24833,5367,15615,-27906,0,9279,-27905,5367
19620 DATA 9471,-27906,0,9023,4863,5367,9471,25342
19621 DATA 0,16511,255,5367,255,511,0,16511
19622 DATA 255,5367,255,511,0,21611,-511,5367
19623 DATA 16320,-27285,0,10295,-32131,5239,8287,-30090
19624 DATA 0,10295,17595,8803,4462,2806,0,10295
19625 DATA 10455,8803,2677,2806,0,4127,4335,8803
19626 DATA 1147,1276,0,4127,14535,8931,3825,1276
19627 DATA 0,4127,255,16833,255,1276,0,2063
19628 DATA 255,-32640,-32513,2296,0,1031,255,-32640
19629 DATA -32513,4336,0,515,511,0,16511,8416
19630 DATA 0,257,766,0,8255,16576,0,0
19631 DATA -32002,0,8255,-32640,0,0,31868,0
19632 DATA 7967,0,0,0,0,0,0,0
19633 DATA 0,771,-1,15934,32639,-7968,0,1799
19634 DATA -1,-25444,-1,-3856,0,3855,-1,-8739
19635 DATA -1,-1800,0,7967,-1,-1,-1,-772
19636 DATA 0,16191,-1,-1,-1,-258,0,16191
19637 DATA -1,-1,-1,-258,0,32639,-1,-1
19638 DATA -1,-1,0,32639,-1,-1,-1,-1
19639 DATA 0,32639,-1,-1,-1,-1,0,32639
19640 DATA -1,-1,-1,-1,0,-1,-1,-1
19641 DATA -1,-1,-32640,-1,-1,-1,-1,-1
19642 DATA -32640,-1,-1,-1,-1,-1,-32640,32639
19643 DATA -1,-1,-1,-1,0,32639,-1,-2057
19644 DATA -1,-1,0,32639,-1,-2057,-1,-1
19645 DATA 0,16191,-1,-2057,-1,-258,0,16191
19646 DATA -1,-2057,-1,-258,0,16191,-1,-7197
19647 DATA -1,-258,0,7967,-1,-15935,-1,-772
19648 DATA 0,3855,-1,-15935,-1,-1800,0,1799
19649 DATA -1,-32640,-1,-3856,0,771,-1,0
19650 DATA 32639,-7968,0,257,-1,0,32639,-16192
19651 DATA 0,0,-258,0,16191,-32640,0,0
19652 DATA 31868,0,7967,0,0,256,16384,41
19653 DATA 26,20,1,0,12,0,320,0
19654 DATA 0,0,0,10794,0,0,0,0
19655 DATA 257,-32612,-16192,0,0,0,257,21973
19656 DATA 16576,0,0,0,515,21973,8416,0
19657 DATA 0,0,515,-23965,-24480,0,0,0
19658 DATA 515,5367,8416,0,0,0,515,-18697
19659 DATA -24352,0,0,0,515,-10761,-24352,0
19660 DATA 0,0,1031,-10761,-28432,0,0,0
19661 DATA 1031,-18697,-28432,0,0,0,515,5367
19662 DATA 8416,0,0,0,515,5367,8416,0
19663 DATA 0,0,515,-2284,-24480,0,0,0
19664 DATA 515,21942,8416,0,0,0,257,21942
19665 DATA 16576,0,0,0,257,25514,16576,0
19666 DATA 0,0,257,25506,16576,0,0,0
19667 DATA 257,-7390,-16320,0,0,0,257,8931
19668 DATA 16576,0,0,0,257,8931,16576,0
19669 DATA 0,0,0,-15935,-32640,0,0,0
19670 DATA 0,-15935,-32640,0,0,0,0,-15935
19671 DATA -32640,0,0,0,0,16705,0,0
19672 DATA 0,0,0,16705,0,0,0,0
19673 DATA 0,0,0,0,0,0,257,-16706
19674 DATA -16192,0,0,0,771,-8739,-7968,0
19675 DATA 0,0,771,-1,-7968,0,0,0
19676 DATA 1799,-1,-3856,0,0,0,1799,-1
19677 DATA -3856,0,0,0,1799,-1,-3856,0
19678 DATA 0,0,1799,-1,-3856,0,0,0
19679 DATA 1799,-1,-3856,0,0,0,3855,-1
19680 DATA -1800,0,0,0,3855,-1,-1800,0
19681 DATA 0,0,1799,-1,-3856,0,0,0
19682 DATA 1799,-1,-3856,0,0,0,1799,-1
19683 DATA -3856,0,0,0,1799,-1,-3856,0
19684 DATA 0,0,771,-1,-7968,0,0,0
19685 DATA 771,-1,-7968,0,0,0,771,-2057
19686 DATA -7968,0,0,0,771,-2057,-7968,0
19687 DATA 0,0,771,-2057,-7968,0,0,0
19688 DATA 771,-2057,-7968,0,0,0,257,-7197
19689 DATA -16192,0,0,0,257,-7197,-16192,0
19690 DATA 0,0,257,-7197,-16192,0,0,0
19691 DATA 0,-7197,-32640,0,0,0,0,-7197
19692 DATA -32640,0,0,0,0,-15935,-32640,0
19693 DATA 0,3,1456,1516,1580,1716,256,0
19694 DATA 9,9,4,2,0,0,0,8
19695 DATA 0,0,32639,0,-1,-32640,-1,-32640
19696 DATA -1,-32640,32639,0,15934,0,7196,0
19697 DATA 2056,0,15934,0,256,0,8,10
19698 DATA 0,9,0,0,0,8,0,0
19699 DATA -13879,0,-28014,0,-28014,0,-28014,0
19700 DATA -13622,0,-30070,0,-30070,0,-30070,0
19701 DATA -30070,0,-11823,0,256,0,29,14
19702 DATA 4,2,0,0,0,8,0,0
19703 DATA 7967,-1,-1,-16192,8224,0,0,8224
19704 DATA 20046,0,0,4112,-30327,0,0,2056
19705 DATA -30327,8224,1028,2056,-30327,8224,1028,2056
19706 DATA -29042,8481,-15164,2056,-30327,8738,10023,2056
19707 DATA -30327,8738,9252,-30584,-30327,8738,9252,-30584
19708 DATA -29042,4369,-14393,2056,16448,0,0,4112
19709 DATA 8224,0,0,8224,7967,-1,-1,-16192
19710 DATA 256,0,14,10,6,4,0,0
19711 DATA 0,8,0,0,-1,-772,-1,-772
19712 DATA -1,-772,-7968,7196,-6169,-25444,-6169,-25444
19713 DATA -7968,7196,-1,-772,-1,-772,-1,-772
19714 DATA 2,1788,1820,1852,256,0,16,1
19715 DATA 0,0,0,12,0,0,0,0
19716 DATA -256,-256,-1,-1,256,0,16,1
19717 DATA 0,0,0,12,0,0,0,0
19718 DATA 255,255,-1,-1,256,0,16,1
19719 DATA 0,0,0,12,0,0,0,0
19720 DATA -1,-1,-1,-1,72,12298,12298,12298
19721 DATA 12853,12810,12593,14602,14346,13578,12554,12810
19722 DATA 11572,13834,14090,12298,12554,12298,14090,13322
19723 DATA 11569,2605,12554,14090,12298,11569,2605,12554
19724 DATA 12298,14090,11569,2605,12554,12853,12810,12593
19725 DATA 14602,3,11569,2560,28211,2610,14346,12597
19726 DATA 2610,2609,2608,2608,2610,2608,2608,2610
19727 DATA 14346,12597,2610,12850,2609,2608,2608,2608
19728 DATA 2608,2609,2617,13322,12597,2611,13322,12554
19729 DATA 12298,12298,11569,2614,14346,12810,14390,2609
19730 DATA 13578,12595,12810,12554,12298,12298,11569,2614
19731 DATA 14090,13066,12810,12298,12554,12810,12298,11575
19732 DATA 2605,12554,11569,2560,0,19504,2610,13360
19733 DATA 2617,13578,12810,12600,2608,2609,2610,2615
19734 DATA 2605,12554,12298,12298,13877,2609,2609,2608
19735 DATA 2615,2612,2605,12554,11569,2615,2608,2605
19736 DATA 12554,11569,2608,2615,2605,12554,11569,2609
19737 DATA 2609,2608,2608,2560,0,4144,2609,12298
19738 DATA 12594,2608,2609,12298,12594,2560,7981,12554
19739 DATA 11569,2608,2609,2608,2608,2608,2608,2608
19740 DATA 2611,2605,12554,11569,2605,12554,6,12298
19741 DATA 12298,12554
19742 DATA 21717
