100 :
110 REMark *************************************************************
120 REMark * The following two lines instruct Turbo how to compile EX2 *
130 REMark *************************************************************
140 :
150 TURBO_objfil 'ram1_EX3_TASK':TURBO_taskn 'EX3 v2.1':TURBO_objdat 100
160 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
170 :
180 REMark EX3_bas
190 REMark 8 DEC 00
200 :
210 IF COMPILED:OPEN#0,con:wch%=100:ELSE :BOUTL:wch%=0
220 :
230 REMark **************************************
240 REMark * wch% is used by M_SETUP, see later *
250 REMark **************************************
260 :
270 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
280 :
290 REMark **********************************************************************
300 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
310 REMark * and sets wd(r), the address(es) of window definition(s)            *
320 REMark **********************************************************************
330 :
340                         REMark **************************
350 OPEN#4,con:wink%=GREEN%:REMark *  for drawing to screen *
360                         REMark **************************
370 :
380 REMark                            **************************************
390 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
400 REMark                            **************************************
410 :
420 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
430 :
440 REMark ************************************************************
450 REMark * We must set a primary window here if this is COMPILED.   *
460 REMark * (PRPOS can be thought of as PRimary POSitioned).         *
470 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
480 REMark * the window here must instead be "pulled down" as a       *
490 REMark * secondary window.                                        *
500 REMark ************************************************************
510 :
520                             REMark *******************
530 SET_CHANNEL#4,SWIN(0,1,wwd):REMark * 2nd inf window  *
540                             REMark *******************
550 :
560                 REMark **************************
570 set_lim:        REMark * Set x/y wee/big for #4 *
580 wron%=1:on_off: REMark * To set on/off to OFF   *
590                 REMark **************************
600 :
610 REMark *******************************************************
620 REMark * This is the repeat loop for reading the pointer and *
630 REMark * taking apropriate action                            *
640 REMark *******************************************************
650 REPeat lp
660  k=WRPTR(wwd)
670  r=255&&get_x%(k)
680  REMark ***************************************
690  REMark * r is the code extracted from k      *
700  REMark * 255 -> a loose item                 *
710  REMark * 254 -> an event                     *
720  REMark * otherwise the number of app. window *
730  REMark *                                     *
740  REMark * get_y%(k) is the bottom word of k   *
750  REMark * and is the item or event number     *
760  REMark ***************************************
770  SELect ON r
780   =255:REMark loose items
790     IF do_loose%(get_y%(k)):EXIT lp
800   =254:REMark event
810     IF do_event%(get_y%(k)):EXIT lp
820   =REMAINDER :REMark application window r
830     IF do_app%(r,get_y%(k)):EXIT lp
840  END SELect
850 END REPeat lp
860 STOP
870 :
880 DEFine PROCedure finish
890  REMark *************************************************
900  REMark * BUNST unsets the working definition           *
910  REMark * BRCHP returns its area to the heap            *
920  REMark * CLOS closes the channel opened for the window *
930  REMark *************************************************
940  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
950  CLOSE#4
960         REMark ***************************************************
970  BRECHP:REMark * Returns the space used by the window definition *
980         REMark ***************************************************
990  STOP
1000 END DEFine
1010 :
1020 DEFine FuNction do_loose%(num%)
1030  REMark routine to do loose items
1040  LOCal k,ans%
1050  k=num%:ans%=0
1060  REMark ********************************************
1070  REMark * There are 5 loose items, numbered 0 to 4 *
1080  REMark * 0 = the move icon                        *
1090  REMark * 1 = the size icon                        *
1100  REMark * 2 = "ESC"                                *
1110  REMark * 3 = "Clear"                              *
1120  REMark * 4 = "OFF" or "ON"                        *
1130  REMark ********************************************
1140  SELect ON k
1150   =2:finish:ans%=1
1160   =1:do_size
1170   =0:mve
1180   =3:CLS#4
1190   =4:on_off:dloop:on_off
1200  END SELect
1210                             REMark **********************************
1220  IF NOT k=2:D_LDRW num%,wwd:REMark * Resets the item to "available" *
1230                             REMark **********************************
1240  RETurn ans%
1250 END DEFine
1260 :
1270 DEFine FuNction do_event%(num%)
1280  REMark ***********************************
1290  REMark * Each of these three events      *
1300  REMark * can also be accessed via the    *
1310  REMark * appropriate loose item          *
1320  REMark * 2 = quit, 8 = move, 16 = resize *
1330  REMark * When the action is done this    *
1340  REMark * returns 1 for stop, 0 for go on *
1350  REMark ***********************************
1360  LOCal as%
1370  as%=0
1380  IF 2&&num%:finish:as%=1
1390  IF 8&&num%:mve
1400  IF 16&&num%:do_size
1410  RETurn as%
1420 END DEFine
1430 :
1440 DEFine FuNction do_app%(wind%,num%)
1450  RETurn 0:REMark "go on"
1460 END DEFine
1470 :
1480 DEFine PROCedure do_size
1490  LOCal mv,xmv%,ymv%,defx%,defy%,oldx%,oldy%,newx%,newy%
1500                REMark *************************************
1510  mv=BCHSZ(wwd):REMark * mv is the reduction in size (x/y) *
1520                REMark *************************************
1530  xmv%=get_x%(mv):ymv%=get_y%(mv)
1540  REMark *************************************************
1550  REMark * We now have to check that the new size is     *
1560  REMark * within reasonable limits. It must be no       *
1570  REMark * bigger than the maximum in the window         *
1580  REMark * definition. It must be no smaller than 2/1.   *
1590  REMark * This size is used in M_SETUP to arrive at the *
1600  REMark * actual size.                                  *
1610  REMark * Note wwd+4 contains the address of the window *
1620  REMark * definition.                                   *
1630  REMark * The maximun size is put in defx%/defy%.       *
1640  REMark * The current size oldx%/oldy% comes from the   *
1650  REMark * working definition + 32.                     *
1660  REMark *************************************************
1670  defx%=PEEK_W(PEEK_L(wwd+4)):defy%=PEEK_W(PEEK_L(wwd+4)+2)
1680  mv=PEEK_L(PEEK_L(wwd)+32)
1690  oldx%=PEEK_W(32+wwd):oldy%=PEEK_W(34+wwd)
1700                                    REMark ********************************
1710  newx%=oldx%-xmv%:newy%=oldy%-ymv%:REMark * the provisional new size . . *
1720  IF newx%<2:newx%=2:               REMark * . . which must not . .       *
1730  IF newy%<1:newy%=1:               REMark * . . be too small . .         *
1740  IF newx%>defx%:newx%=defx%:       REMark * . . or too . .               *
1750  IF newy%>defy%:newy%=defy%:       REMark * . . large                    *
1760  newx%=ev%(newx%):                 REMark * NB!! x-values MUST be even   *
1770                                    REMark ********************************
1780 :
1790  REMark *****************************************************
1800  REMark * BUNST unsets the working definition and throws    *
1810  REMark * away the window if NOT COMPILED.                  *
1820  REMark * BRCHP returns its area to the heap.               *
1830  REMark * CLOS closes the channel opened if not COMPILED.   *
1840  REMark * M_SETUP sets up the new working definition and    *
1850  REMark * gives us its address (in wwd).                    *
1860  REMark * M_PRPOS throws away the old window and sets up    *
1870  REMark * a new one. M_PULLD pulls down a secondary window. *
1880  REMark * All that remains is to reset #4, find the limits  *
1890  REMark * to this window via set_lim and to set on/off to   *
1900  REMark * OFF just as for a window move.                    *
1910  REMark *****************************************************
1920  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
1930  wwd=M_SETUP(#wch%,wd(0),newx%*2^16+newy%)
1940  IF COMPILED:chid=M_PRPOS(wwd,mv):ELSE :chid=M_PULLD(wwd,mv)
1950  SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off
1960  set_lim
1970 END DEFine
1980 :
1990 DEFine PROCedure mve
2000  REMark ***************************************
2010  REMark * On a move we must:                  *
2020  REMark *     1. reset #4                     *
2030  REMark *     2. set on/off -> OFF            *
2040  REMark *     3. reset the limits for drawing *
2050  REMark ***************************************
2060  BCHWIN wwd:SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off:set_lim
2070 END DEFine
2080 :
2090 DEFine PROCedure on_off
2100  REMark *******************************************
2110  REMark * This sets loose item 4 on<->off         *
2120  REMark * and sets wron%=1<->0.                   *
2130  REMark * wron%^^1 switches wron% between 0 and 1 *
2140  REMark * STLOB sets ON or OFF to loose item 4.   *
2150  REMark * g_txt returns the address of the text   *
2160  REMark * item number 2 or 3 ie "ON " or "OFF",   *
2170  REMark * (See EX3_text_list.)                    *
2180  REMark *******************************************
2190  STLOB 4,g_txt(wron%+2),wwd:wron%=wron%^^1
2200  D_LDRW 4,wwd
2210 END DEFine
2220 :
2230 DEFine PROCedure blk(w)
2240  LOCal px%,py%
2250  REMark **************************************
2260  REMark *  w is the pointer position.        *
2270  REMark *  A two by one block is drawn there *
2280  REMark *  provided it fits in #4.           *
2290  REMark **************************************
2300  px%=get_x%(w):py%=get_y%(w)
2310  IF xwee%<=px% AND px%<xbig%-1 AND ywee%<=py% AND py%<ybig%
2320   BLOCK#4,2,1,px%-xwee%,py%-ywee%,wink%
2330  END IF
2340 END DEFine
2350 :
2360 DEFine PROCedure dloop
2370  LOCal pptr,kk,lp
2380  REMark **********************************
2390  REMark * The pointer is read directly - *
2400  REMark * returning on a key stroke or a *
2410  REMark * key held down.                 *
2420  REMark **********************************
2430 :
2440  REMark *******************************
2450  REMark * First we set pptr to the current pointer position *
2460  REMark * Then via BRPTR we discover what key has been *
2470  REMark * pressed and act accordingly.                *
2480  pptr=WH_PTR(wwd):REMark * ex3 - Current pointer position *
2490  REPeat lp
2500   pptr=BRPTR(3,pptr,wwd): REMark * ex3 - new position     *
2510   kk=PEEK(PEEK_L(wwd)+18):REMark * ex3 - key stroke       *
2520   SELect ON kk
2530    =0,1:blk pptr
2540    =CODE('C'),CODE('c'):CLS#4
2550    =2:EXIT lp:       REMark * ex3 - Return to the main menu *
2560    =CODE('g'),CODE("G"):wink%=GREEN%:REMark * ex3 - These   *
2570    =CODE('r'),CODE("R"):wink%=RED%:  REMark * ex3 - set the *
2580    =CODE('w'),CODE("W"):wink%=WHITE%:REMark * ex3 - block   *
2590    =CODE('b'),CODE("B"):wink%=BLACK%:REMark * ex3 - colour  *
2600   END SELect
2610  END REPeat lp
2620 END DEFine
2630 :
2640 DEFine PROCedure set_lim
2650  LOCal ach
2660  REMark * ex3 - ach is #4's base                                *
2670  REMark * ex3 - xwee%/ywee% is the top left extreme for a block *
2680  REMark * ex3 - xbig%/ybig% is the bottom right extreme         *
2690  ach=CH_BAS(CHANNEL_ID(#4))
2700  xwee%=PEEK_W(ach+24):ywee%=PEEK_W(ach+26)
2710  xbig%=PEEK_W(ach+28)+xwee%:ybig%=PEEK_W(ach+30)+ywee%
2720 END DEFine
2730 :
19600 DATA 2186
19601 DATA 19,17747,17162,17260,25953,29194,20302,8202
19602 DATA 20294,17930,2567,18949,-23035,-5632,256,1541
19603 DATA 5633,32,0,10496,6656,5120,256,0
19604 DATA 3072,1,16384,2,29696,0,42,10752
19605 DATA 0,0,3,1023,-236,5247,32736,-8192
19606 DATA 4,1792,-108,-27520,-240,-4096,8,3840
19607 DATA -171,-11008,-248,-2048,17,7754,-19166,-7383
19608 DATA -10684,-17408,16,7936,-236,-2304,-252,-1024
19609 DATA 35,16146,-236,-2268,-158,-512,36,16286
19610 DATA -236,-2244,-110,-512,36,16274,-236,-2268
19611 DATA -110,-512,35,16146,-236,-2268,-158,-512
19612 DATA 64,32512,-236,-2304,-255,-256,64,32512
19613 DATA -236,-2304,-255,-256,84,27646,276,-2241
19614 DATA -16235,27392,40,14210,32020,30496,24458,30208
19615 DATA 40,14148,-17630,25361,28170,-2560,40,14120
19616 DATA -10462,25354,29962,-2560,16,7952,-4318,25348
19617 DATA 31492,-1024,16,7992,-14558,-7410,-3836,-1024
19618 DATA 16,7936,-191,-16128,-252,-1024,8,3840
19619 DATA -128,-32640,-248,-2048,4,1792,-128,-32640
19620 DATA -240,-4096,2,769,-256,64,32544,-8192
19621 DATA 1,258,-512,32,16192,-16384,0,130
19622 DATA -512,32,16256,-32768,0,124,31744,31
19623 DATA 7936,0,0,0,0,0,0,0
19624 DATA 3,1023,-194,15999,32736,-8192,7,2047
19625 DATA -100,-25345,-16,-4096,15,4095,-35,-8705
19626 DATA -8,-2048,31,8191,-1,-1,-4,-1024
19627 DATA 63,16383,-1,-1,-2,-512,63,16383
19628 DATA -1,-1,-2,-512,127,32767,-1,-1
19629 DATA -1,-256,127,32767,-1,-1,-1,-256
19630 DATA 127,32767,-1,-1,-1,-256,127,32767
19631 DATA -1,-1,-1,-256,255,-1,-1,-1
19632 DATA -1,-128,-32513,-1,-1,-1,-1,-128
19633 DATA -32513,-1,-1,-1,-1,-128,-32641,32767
19634 DATA -1,-1,-1,-256,127,32767,-9,-2049
19635 DATA -1,-256,127,32767,-9,-2049,-1,-256
19636 DATA 63,16383,-9,-2049,-2,-512,63,16383
19637 DATA -9,-2049,-2,-512,63,16383,-29,-7169
19638 DATA -2,-512,31,8191,-63,-15873,-4,-1024
19639 DATA 15,4095,-63,-15873,-8,-2048,7,2047
19640 DATA -128,-32513,-16,-4096,3,1023,-256,127
19641 DATA 32736,-8192,1,511,-256,127,32704,-16384
19642 DATA 0,254,-512,63,16256,-32768,0,124
19643 DATA 31744,31,7936,0,1,64,0,10496
19644 DATA 6656,5120,256,0,3072,1,16384,0
19645 DATA 0,0,42,10752,0,0,0,1
19646 DATA 384,-25408,-16384,0,0,1,341,-10944
19647 DATA -16384,0,0,2,853,-10976,-8192,0
19648 DATA 0,2,930,25504,24576,0,0,2
19649 DATA 788,-2272,-8192,0,0,2,950,-2144
19650 DATA -8192,0,0,2,981,-2144,-8192,0
19651 DATA 0,4,2005,-2160,-4096,0,0,4
19652 DATA 1974,-2160,-4096,0,0,2,788,-2272
19653 DATA -8192,0,0,2,788,-2272,-8192,0
19654 DATA 0,2,1015,5280,24576,0,0,2
19655 DATA 853,-18912,-8192,0,0,1,341,-18880
19656 DATA -16384,0,0,1,355,-21952,-16384,0
19657 DATA 0,1,355,-24000,-16384,0,0,1
19658 DATA 483,8896,16384,0,0,1,290,-7360
19659 DATA -16384,0,0,1,290,-7360,-16384,0
19660 DATA 0,0,193,-16000,-32768,0,0,0
19661 DATA 193,-16000,-32768,0,0,0,193,-16000
19662 DATA -32768,0,0,0,65,16640,0,0
19663 DATA 0,0,65,16640,0,0,0,0
19664 DATA 0,0,0,0,0,1,446,-16704
19665 DATA -16384,0,0,3,989,-8736,-8192,0
19666 DATA 0,3,1023,-32,-8192,0,0,7
19667 DATA 2047,-16,-4096,0,0,7,2047,-16
19668 DATA -4096,0,0,7,2047,-16,-4096,0
19669 DATA 0,7,2047,-16,-4096,0,0,7
19670 DATA 2047,-16,-4096,0,0,15,4095,-8
19671 DATA -2048,0,0,15,4095,-8,-2048,0
19672 DATA 0,7,2047,-16,-4096,0,0,7
19673 DATA 2047,-16,-4096,0,0,7,2047,-16
19674 DATA -4096,0,0,7,2047,-16,-4096,0
19675 DATA 0,3,1023,-32,-8192,0,0,3
19676 DATA 1023,-32,-8192,0,0,3,1015,-2080
19677 DATA -8192,0,0,3,1015,-2080,-8192,0
19678 DATA 0,3,1015,-2080,-8192,0,0,3
19679 DATA 1015,-2080,-8192,0,0,1,483,-7232
19680 DATA -16384,0,0,1,483,-7232,-16384,0
19681 DATA 0,1,483,-7232,-16384,0,0,0
19682 DATA 227,-7296,-32768,0,0,0,227,-7296
19683 DATA -32768,0,0,0,193,-16000,-32768,0
19684 DATA 1,32,0,1280,1280,512,512,0
19685 DATA 3072,0,7168,0,11264,0,32,8192
19686 DATA 80,20480,32,8192,0,0,32,8192
19687 DATA 112,28672,248,-2048,112,28672,32,8192
19688 DATA 1,64,0,2304,1792,1024,768,0
19689 DATA 3072,0,9216,0,0,0,8,2048
19690 DATA 20,5120,34,8704,20,5120,8,2048
19691 DATA 0,0,8,2048,28,7168,62,15872
19692 DATA 127,32512,62,15872,28,7168,8,2048
19693 DATA 0,5,-22015,0,0,2048,2560,0
19694 DATA 2304,0,0,0,2048,0,201,-14080
19695 DATA 146,-28160,146,-28160,146,-28160,202,-13824
19696 DATA 138,-30208,138,-30208,138,-30208,138,-30208
19697 DATA 209,-12032,0,2053,-506,7686,17926,28166
19698 DATA -27130,-16890,-6649,1543,9729,0,0,4096
19699 DATA 256,0,0,0,3072,0,0,0
19700 DATA 0,0,255,-1,-255,0,0,4096
19701 DATA 512,0,0,0,3072,0,0,0
19702 DATA 170,170,85,85,255,-1,-1,-1
19703 DATA -255,0,0,4096,512,0,0,0
19704 DATA 3072,0,0,0,0,-22016,-22016,21760
19705 DATA 22015,-1,-1,-1,-255,0,0,4096
19706 DATA 512,0,0,0,3072,0,0,0
19707 DATA 255,22015,22015,-21761,-21761,-1,-1,-1
19708 DATA -255,0,0,4096,512,0,0,0
19709 DATA 3072,0,0,0,85,-171,-86,-86
19710 DATA -1,-1,-1,-1,-255,0,0,4096
19711 DATA 512,0,0,0,3072,0,0,0
19712 DATA 170,-21846,-21931,21845,22015,-1,-1,-1
19713 DATA -255,0,0,4096,256,0,0,0
19714 DATA 3072,0,0,0,0,-256,-1,-1
19715 DATA -255,0,0,4096,256,0,0,0
19716 DATA 3072,0,0,0,255,255,255,-1
19717 DATA -255,0,0,4096,256,0,0,0
19718 DATA 3072,0,0,0,255,-1,-1,-1
19719 DATA -256,19760,2608,2605,12554,13106,12810,12597
19720 DATA 13578,13322,13322,12554,12810,11570,12810,14090
19721 DATA 12554,12554,12298,14090,13322,11569,2605,12554
19722 DATA 14090,12298,11569,2605,12554,12298,14090,11569
19723 DATA 2605,12554,12598,13625,12298,12598,13616,14602
19724 DATA 55,12554,12598,13367,12810,12598,2615,13322
19725 DATA 12298,12298,12298,12298,11569,14132,2609,13877
19726 DATA 13874,2609,13876,14384,2609,13322,12851,2608
19727 DATA 2610,2605,12596,2608,2560,-30156,2609,13834
19728 DATA 12596,2610,2609,2608,2608,2610,2608,2608
19729 DATA 2609,13834,12596,2610,12810,12554,12298,12298
19730 DATA 12810,12298,12554,12600,2609,13322,12598,13623
19731 DATA 12298,12554,12298,12298,12298,12298,12810,13104
19732 DATA 2609,13322,13362,2609,2608,2608,2605,12554
19733 DATA 13879,2611,2609,14346,12596,2609,13877,13368
19734 DATA 2609,2608,2608,2605,12554,14137,2612,2610
19735 DATA 2608,2609,2610,2609,2605,14090,11576,2605
19736 DATA 12554,11569,2560,1581,12554,11569,2560,813
19737 DATA 12554,0,0,0,0
19738 DATA 18510
